import BridgeIDBTransaction from "./BridgeIDBTransaction";
import FakeEventTarget from "./util/FakeEventTarget";
import { FakeDOMStringList, KeyPath, TransactionMode } from "./util/types";
import { Backend, DatabaseConnection, Schema, DatabaseTransaction } from "./backend-interface";
declare class BridgeIDBDatabase extends FakeEventTarget {
    _closePending: boolean;
    _closed: boolean;
    _runningVersionchangeTransaction: boolean;
    _transactions: Array<BridgeIDBTransaction>;
    _backendConnection: DatabaseConnection;
    _backend: Backend;
    _schema: Schema;
    get name(): string;
    get version(): number;
    get objectStoreNames(): FakeDOMStringList;
    /**
     * http://www.w3.org/TR/2015/REC-IndexedDB-20150108/#database-closing-steps
     */
    _closeConnection(): void;
    constructor(backend: Backend, backendConnection: DatabaseConnection);
    createObjectStore(name: string, options?: {
        autoIncrement?: boolean;
        keyPath?: KeyPath;
    } | null): import("./BridgeIDBObjectStore").default;
    deleteObjectStore(name: string): void;
    _internalTransaction(storeNames: string | string[], mode?: TransactionMode, backendTransaction?: DatabaseTransaction): BridgeIDBTransaction;
    transaction(storeNames: string | string[], mode?: TransactionMode): BridgeIDBTransaction;
    close(): void;
    toString(): string;
}
export default BridgeIDBDatabase;
