import BridgeIDBKeyRange from "./BridgeIDBKeyRange";
import BridgeIDBObjectStore from "./BridgeIDBObjectStore";
import BridgeIDBRequest from "./BridgeIDBRequest";
import { BridgeIDBCursorDirection, Key, KeyPath } from "./util/types";
import { Schema, Backend, DatabaseTransaction } from "./backend-interface";
export declare class BridgeIDBIndex {
    objectStore: BridgeIDBObjectStore;
    get _schema(): Schema;
    get keyPath(): KeyPath;
    get multiEntry(): boolean;
    get unique(): boolean;
    get _backend(): Backend;
    _confirmActiveTransaction(): {
        btx: DatabaseTransaction;
    };
    private _name;
    _deleted: boolean;
    constructor(objectStore: BridgeIDBObjectStore, name: string);
    get name(): any;
    set name(name: any);
    openCursor(range?: BridgeIDBKeyRange | Key | null | undefined, direction?: BridgeIDBCursorDirection): BridgeIDBRequest;
    openKeyCursor(range?: BridgeIDBKeyRange | Key | null | undefined, direction?: BridgeIDBCursorDirection): BridgeIDBRequest;
    get(key: BridgeIDBKeyRange | Key): BridgeIDBRequest;
    getAll(query?: BridgeIDBKeyRange | Key, count?: number): void;
    getKey(key: BridgeIDBKeyRange | Key): BridgeIDBRequest;
    getAllKeys(query?: BridgeIDBKeyRange | Key, count?: number): void;
    count(key: BridgeIDBKeyRange | Key | null | undefined): BridgeIDBRequest;
    toString(): string;
}
export default BridgeIDBIndex;
