import BridgeIDBIndex from "./BridgeIDBIndex";
import BridgeIDBKeyRange from "./BridgeIDBKeyRange";
import BridgeIDBRequest from "./BridgeIDBRequest";
import BridgeIDBTransaction from "./BridgeIDBTransaction";
import { FakeDOMStringList, BridgeIDBCursorDirection, Key, KeyPath, Value } from "./util/types";
import { DatabaseTransaction } from "./backend-interface";
declare class BridgeIDBObjectStore {
    _indexesCache: Map<string, BridgeIDBIndex>;
    transaction: BridgeIDBTransaction;
    get autoIncrement(): boolean;
    get indexNames(): FakeDOMStringList;
    get keyPath(): KeyPath | null;
    _name: string;
    get _schema(): import("./backend-interface").Schema;
    _deleted: boolean;
    constructor(transaction: BridgeIDBTransaction, name: string);
    get name(): any;
    get _backend(): import("./backend-interface").Backend;
    get _backendConnection(): import("./backend-interface").DatabaseConnection;
    _confirmActiveTransaction(): {
        btx: DatabaseTransaction;
    };
    set name(newName: any);
    _store(value: Value, key: Key | undefined, overwrite: boolean): BridgeIDBRequest;
    put(value: Value, key?: Key): BridgeIDBRequest;
    add(value: Value, key?: Key): BridgeIDBRequest;
    delete(key: Key | BridgeIDBKeyRange): BridgeIDBRequest;
    get(key?: BridgeIDBKeyRange | Key): BridgeIDBRequest;
    getAll(query?: BridgeIDBKeyRange | Key, count?: number): void;
    getKey(key?: BridgeIDBKeyRange | Key): void;
    getAllKeys(query?: BridgeIDBKeyRange | Key, count?: number): void;
    clear(): void;
    openCursor(range?: BridgeIDBKeyRange | Key, direction?: BridgeIDBCursorDirection): BridgeIDBRequest;
    openKeyCursor(range?: BridgeIDBKeyRange | Key, direction?: BridgeIDBCursorDirection): BridgeIDBRequest;
    createIndex(indexName: string, keyPath: KeyPath, optionalParameters?: {
        multiEntry?: boolean;
        unique?: boolean;
    }): BridgeIDBIndex;
    index(name: string): BridgeIDBIndex;
    deleteIndex(indexName: string): void;
    count(key?: Key | BridgeIDBKeyRange): BridgeIDBRequest;
    toString(): string;
}
export default BridgeIDBObjectStore;
