import BridgeIDBDatabase from "./BridgeIDBDatabase";
import BridgeIDBObjectStore from "./BridgeIDBObjectStore";
import BridgeIDBRequest from "./BridgeIDBRequest";
import FakeEventTarget from "./util/FakeEventTarget";
import { EventCallback, FakeDOMStringList, RequestObj, TransactionMode } from "./util/types";
import { DatabaseTransaction, Backend } from "./backend-interface";
declare class BridgeIDBTransaction extends FakeEventTarget {
    _state: "active" | "inactive" | "committing" | "finished";
    _started: boolean;
    _objectStoresCache: Map<string, BridgeIDBObjectStore>;
    _backendTransaction?: DatabaseTransaction;
    objectStoreNames: FakeDOMStringList;
    mode: TransactionMode;
    db: BridgeIDBDatabase;
    error: Error | null;
    onabort: EventCallback | null;
    oncomplete: EventCallback | null;
    onerror: EventCallback | null;
    private _waitPromise;
    private _resolveWait;
    _scope: Set<string>;
    private _requests;
    get _backend(): Backend;
    constructor(storeNames: string[], mode: TransactionMode, db: BridgeIDBDatabase, backendTransaction?: DatabaseTransaction);
    _abort(errName: string | null): Promise<void>;
    abort(): void;
    objectStore(name: string): BridgeIDBObjectStore;
    _execRequestAsync(obj: RequestObj): BridgeIDBRequest;
    /**
     * Actually execute the scheduled work for this transaction.
     */
    _start(): Promise<void>;
    commit(): void;
    toString(): string;
    _waitDone(): Promise<void>;
}
export default BridgeIDBTransaction;
