import BridgeIDBRequest from "../BridgeIDBRequest";
import BridgeIDBKeyRange from "../BridgeIDBKeyRange";
import BridgeIDBIndex from "../BridgeIDBIndex";
import BridgeIBObjectStore from "../BridgeIDBObjectStore";
import { Event } from "../util/FakeEvent";
interface EventInCallback extends Event {
    target: any;
    error: Error | null;
}
export declare type EventCallback = (event: EventInCallback) => void;
export declare type EventType = "abort" | "blocked" | "complete" | "error" | "success" | "upgradeneeded" | "versionchange";
export declare type CursorSource = BridgeIDBIndex | BridgeIBObjectStore;
export interface FakeDOMStringList extends Array<string> {
    contains: (value: string) => boolean;
    item: (i: number) => string | undefined;
}
export declare type BridgeIDBCursorDirection = "next" | "nextunique" | "prev" | "prevunique";
export declare type KeyPath = string | string[];
export declare type Key = any;
export declare type CursorRange = Key | BridgeIDBKeyRange | undefined;
export declare type Value = any;
export interface Record {
    key: Key;
    value: Key | Value;
}
export declare type TransactionMode = "readonly" | "readwrite" | "versionchange";
export interface BridgeIDBDatabaseInfo {
    name: string;
    version: number;
}
export interface RequestObj {
    operation: () => Promise<any>;
    request?: BridgeIDBRequest | undefined;
    source?: any;
}
export {};
